﻿// For NotifyPropertyChanged, see http://www.codeproject.com/Articles/383514/PriorityObject-more-fluent-than-PriorityBinding-in

using System.ComponentModel;
using CBdotnet;
using System.Threading;

namespace PriorityObjectCodeComparison
{
	public class PriorityObjectAsyncDataSource : INotifyPropertyChanged
	{
		// Builder:
		public PriorityObjectAsyncDataSource()
		{
			_TextByPriorityObject = new PriorityObject<string>
				("TextByPriorityObject", this.NotifyPropertyChanged, new PriorityObjectDelegates<string>() {

			()=>
			{
				// This simulates a lengthy time before the
				// data being bound to is actualy available.
				Thread.Sleep(5000);
				return "Slowest Value";    },

			()=>
			{
				// This simulates a lengthy time before the
				// data being bound to is actualy available.
				Thread.Sleep(3000);
				return "Slower Value";    }
		 
			}, false, "Fast Value");
		}

		private PriorityObject<string> _TextByPriorityObject;
		public string TextByPriorityObject { get { return this._TextByPriorityObject.Value; } }

		// The INotifyPropertyChanged
		public event PropertyChangedEventHandler PropertyChanged;

		private void NotifyPropertyChanged(string info) // This standard procedure is necessary to PriorityObject.
		{
			if (PropertyChanged != null)
				PropertyChanged(this, new PropertyChangedEventArgs(info));
		}
	}
}
